      subroutine pol1(t,y,yp)
************************************************************************
*                                                                      *
*  Compute the right-hand sides of the Altarelli-Parisi equations      *
*  for the polarised parton densities.                                 *
*                                                                      *
*  Version of Jan 18, 2000.                                            *
*                                                                      *
************************************************************************
$include apeno.h
$include qcd.h
$include grids.h
$include gss32.h
$include speed.h
$include apesf.h
      dimension y(*), yp(*), f0(meqn), f(meqn)
************************************************************************
*     Initialise: alfs=alpha(s)/(2 pi).                                *
************************************************************************
      call spline(y)
      if (nf.eq.3) then
         bt0=bt03
         calf=bt13/bt0/bt0
         tr=tr3
         cg01=cg013
      else if (nf.eq.4) then
         bt0=bt04
         calf=bt14/bt0/bt0
         tr=tr4
         cg01=cg014
      else
         bt0=bt05
         calf=bt15/bt0/bt0
         tr=tr5
         cg01=cg015
      end if
      alfs=2*(1-calf*log(t)/t)/bt0/t
************************************************************************
*     The main control loop.                                           *
************************************************************************
      do 10 ix=1,nxgrd-1
         z0=0.5*(1+x0(ix))
         dz=0.5*(1-x0(ix))
         call splevl(x0(ix),klo(ix,0),f0)
         sigma0=f0(nq0)+f0(nu)+f0(nd)
*
         t1=0.0		! accumulators for the LO integrals
         t2=0.0
         t3=0.0
         t4=0.0
         t5=0.0
         t6=0.0
         t7=0.0
         do 11 ig=1,mgaus
************************************************************************
*           One of the Gauss-Legendre points.                          *
************************************************************************
            z=z0+dz*xg(ig)
            call splevl(x0(ix)/z,klo(ix,ig),f)
            do 12 i=nu,ng
 12            f(i)=f(i)/z
            sigma=f(nq0)+f(nu)+f(nd)
************************************************************************
*           The integrands to be evaluated at LO.                      *
************************************************************************
            f1p=spl1(1,ig,ix)*(f(nu)-f0(nu))
            f2p=spl1(1,ig,ix)*(f(nd)-f0(nd))
            f3p=spl1(1,ig,ix)*(f(nq0)-f0(nq0))+tr*spl1(2,ig,ix)*f(ng)
            f4p=spl1(1,ig,ix)*(f(nq3)-f0(nq3))
            f5p=spl1(1,ig,ix)*(f(nq8)-f0(nq8))
            f6p=spl1(1,ig,ix)*(f(nq15)-f0(nq15))
            f7p=spl1(5,ig,ix)*(f(ng)-f0(ng))+spl1(4,ig,ix)*f(ng)
     1         +spl1(3,ig,ix)*sigma
************************************************************************
*           Another of the Gauss-Legendre points.                      *
************************************************************************
            z=z0-dz*xg(ig)
            call splevl(x0(ix)/z,klo(ix,mgaus+ig),f)
            do 15 i=nu,ng
 15            f(i)=f(i)/z
            sigma=f(nq0)+f(nu)+f(nd)
************************************************************************
*           The integrands to be evaluated at LO.                      *
************************************************************************
            f1m=spl1(1,mgaus+ig,ix)*(f(nu)-f0(nu))
            f2m=spl1(1,mgaus+ig,ix)*(f(nd)-f0(nd))
            f3m=spl1(1,mgaus+ig,ix)*(f(nq0)-f0(nq0))
     1         +tr*spl1(2,mgaus+ig,ix)*f(ng)
            f4m=spl1(1,mgaus+ig,ix)*(f(nq3)-f0(nq3))
            f5m=spl1(1,mgaus+ig,ix)*(f(nq8)-f0(nq8))
            f6m=spl1(1,mgaus+ig,ix)*(f(nq15)-f0(nq15))
            f7m=spl1(5,mgaus+ig,ix)*(f(ng)-f0(ng))
     1         +spl1(4,mgaus+ig,ix)*f(ng)+spl1(3,mgaus+ig,ix)*sigma
************************************************************************
*           The accumulators are updated.                              *
************************************************************************
            t1=t1+wg(ig)*(f1p+f1m)
            t2=t2+wg(ig)*(f2p+f2m)
            t3=t3+wg(ig)*(f3p+f3m)
            t4=t4+wg(ig)*(f4p+f4m)
            t5=t5+wg(ig)*(f5p+f5m)
            t6=t6+wg(ig)*(f6p+f6m)
            t7=t7+wg(ig)*(f7p+f7m)
 11         continue
************************************************************************
*        The compensatory parts are computed.                          *
************************************************************************
         qx0=alfs*cf*(x0(ix)*(1+0.5*x0(ix))+2*xl(ix))
         gx0=alfs*(cg01+cg02*xl(ix))
************************************************************************
*        The result is computed.                                       *
************************************************************************
         dx=alfs*dz
         yp(ix+m1u*nxgrd)  =qx0*f0(nu)+dx*t1
         yp(ix+m1d*nxgrd)  =qx0*f0(nd)+dx*t2
         yp(ix+m1q0*nxgrd) =qx0*f0(nq0)+dx*t3
         yp(ix+m1q3*nxgrd) =qx0*f0(nq3)+dx*t4
         yp(ix+m1q8*nxgrd) =qx0*f0(nq8)+dx*t5
         yp(ix+m1q15*nxgrd)=qx0*f0(nq15)+dx*t6
10       yp(ix+m1g*nxgrd)  =gx0*f0(ng)+dx*t7
*
      do 16 i=1,meqn
 16      yp(i*nxgrd)=0.
*
      return
      end
      subroutine unpol1(t,y,yp)
************************************************************************
*                                                                      *
*  Compute the right-hand sides of the Altarelli-Parisi equations      *
*  for the unpolarised parton densities.                               *
*                                                                      *
*  Version of Jan 18, 2000.                                            *
*                                                                      *
************************************************************************
$include apeno.h
$include qcd.h
$include grids.h
$include gss32.h
$include speed.h
$include apesf.h
      dimension y(*), yp(*), f0(meqn), f(meqn)
************************************************************************
*     Initialise: alfs=alpha(s)/(2 pi).                                *
************************************************************************
      call spline(y)
      if (nf.eq.3) then
         bt0=bt03
         calf=bt13/bt0/bt0
         tr=tr3
         cg01=cg013
      else if (nf.eq.4) then
         bt0=bt04
         calf=bt14/bt0/bt0
         tr=tr4
         cg01=cg014
      else
         bt0=bt05
         calf=bt15/bt0/bt0
         tr=tr5
         cg01=cg015
      end if
      alfs=2*(1-calf*log(t)/t)/bt0/t
************************************************************************
*     The main control loop.                                           *
************************************************************************
      do 10 ix=1,nxgrd-1
         z0=0.5*(1+x0(ix))
         dz=0.5*(1-x0(ix))
         call splevl(x0(ix),klo(ix,0),f0)
         sigma0=f0(nq0)+f0(nu)+f0(nd) ! need q3, q8, q15 and q24 also
*
         t1=0.0
         t2=0.0
         t3=0.0
         t4=0.0
         t5=0.0
         t6=0.0
         t7=0.0
         do 11 ig=1,mgaus
************************************************************************
*           One of the Gauss-Legendre points.                          *
************************************************************************
            z=z0+dz*xg(ig)
            z2p1=1+z*z
            zm1=1-z
            zm2=(1-z)*(1-z)
            call splevl(x0(ix)/z,klo(ix,ig),f)
            do 17 i=nu,ng 
 17            f(i)=f(i)/z
            sigma=f(nq0)+f(nu)+f(nd)
************************************************************************
*           The integrands to be evaluated at LO.                      *
************************************************************************
            f1p=spl1(1,ig,ix)*(f(nu)-f0(nu))
            f2p=spl1(1,ig,ix)*(f(nd)-f0(nd))
            f3p=spl1(1,ig,ix)*(f(nq0)-f0(nq0))
     1         +2*tr*(1-2*z*zm1)*f(ng)
            f4p=spl1(1,ig,ix)*(f(nq3)-f0(nq3))
            f5p=spl1(1,ig,ix)*(f(nq8)-f0(nq8))
            f6p=spl1(1,ig,ix)*(f(nq15)-f0(nq15))
            f7p=spl1(5,ig,ix)*(f(ng)-f0(ng))
     1         +cg02*zm1*z2p1*f(ng)/z+cf*(1+zm2)*sigma/z
************************************************************************
*           Another of the Gauss-Legendre points.                      *
************************************************************************
            z=z0-dz*xg(ig)
            z2p1=1+z*z
            zm1=1-z
            zm2=(1-z)*(1-z)
            call splevl(x0(ix)/z,klo(ix,mgaus+ig),f)
            do 18 i=nu,ng
 18            f(i)=f(i)/z
            sigma=f(nq0)+f(nu)+f(nd)
************************************************************************
*           The integrands to be evaluated at LO.                      *
************************************************************************
            f1m=spl1(1,mgaus+ig,ix)*(f(nu)-f0(nu))
            f2m=spl1(1,mgaus+ig,ix)*(f(nd)-f0(nd))
            f3m=spl1(1,mgaus+ig,ix)*(f(nq0)-f0(nq0))
     1         +2*tr*(1-2*z*zm1)*f(ng)
            f4m=spl1(1,mgaus+ig,ix)*(f(nq3)-f0(nq3))
            f5m=spl1(1,mgaus+ig,ix)*(f(nq8)-f0(nq8))
            f6m=spl1(1,mgaus+ig,ix)*(f(nq15)-f0(nq15))
            f7m=spl1(5,mgaus+ig,ix)*(f(ng)-f0(ng))
     1         +cg02*zm1*z2p1*f(ng)/z+cf*(1+zm2)*sigma/z
************************************************************************
*           The accumulators are updated.                              *
************************************************************************
            t1=t1+wg(ig)*(f1p+f1m)
            t2=t2+wg(ig)*(f2p+f2m)
            t3=t3+wg(ig)*(f3p+f3m)
            t4=t4+wg(ig)*(f4p+f4m)
            t5=t5+wg(ig)*(f5p+f5m)
            t6=t6+wg(ig)*(f6p+f6m)
            t7=t7+wg(ig)*(f7p+f7m)
 11         continue
************************************************************************
*        The compensatory parts are computed.                          *
************************************************************************
         qx0=alfs*cf*(x0(ix)*(1+0.5*x0(ix))+2*xl(ix))
         gx0=alfs*(cg01+cg02*xl(ix))
************************************************************************
*        The result is computed.                                       *
************************************************************************
         dx=alfs*dz
         yp(ix+m1u*nxgrd)  =qx0*f0(nu)+dx*t1
         yp(ix+m1d*nxgrd)  =qx0*f0(nd)+dx*t2
         yp(ix+m1q0*nxgrd) =qx0*f0(nq0)+dx*t3
         yp(ix+m1q3*nxgrd) =qx0*f0(nq3)+dx*t4
         yp(ix+m1q8*nxgrd) =qx0*f0(nq8)+dx*t5
         yp(ix+m1q15*nxgrd)=qx0*f0(nq15)+dx*t6
 10      yp(ix+m1g*nxgrd)  =gx0*f0(ng)+dx*t7
*
      do 19 i=1,meqn
 19      yp(i*nxgrd)=0.
*
      return
      end

