      subroutine unpol
************************************************************************
*                                                                      *
*     Scale the A1 data and errors by the value of F1.                 *
*     Version of Jan 14, 2000.                                         *
*                                                                      *
************************************************************************
$include apeno.h
$include grids.h
$include gss32.h
$include datacom.h
$include nucl.h
$include dsped.h
      external unpol1
      dimension y(meqn*mxgrd), f(meqn)
      common /extras/ eps, h1, hmin, alsq, neqn
************************************************************************
*                                                                      *
*     Integrate the apes.                                              *
*                                                                      *
************************************************************************
      call initf1(y)
      nf=neff(0)
*
      do 20 iq=1,nqgrd
         if (neff(iq).ne.nf) then
            nf=neff(iq)
            go to 20
         end if
*
         h1=(q2(iq)-q2(iq-1))/4.0
         hmin=0.0
         call odeint(y,neqn,q2(iq-1),q2(iq),eps,h1,hmin,nok,nbad,unpol1)
************************************************************************
*        Impose boundary conditions on the charm quark.                *
************************************************************************
         if (nf.lt.4) then
            do 25 ix=1,nxgrd
 25            y(ix+m1q15*nxgrd)=y(ix+m1q0*nxgrd)
         end if
         call spline(y)
************************************************************************
*        Compute the scaling factor for the data.                      *
************************************************************************
         do 21 iexp=1,nexp
            kode=key(iexp)
            if ((kode.eq.kprot).or.(kode.eq.kneut)) then
               cfac=1.0
            else if (kode.eq.kdeut) then
               cfac=facd
            else
               go to 21
            end if
            do 22 ix=1,ndx
               iptr=indx(ix,iexp,iq)
               if (iptr.gt.0) then
c                 write(*,'(a,6i4)') '_|', iq, iexp, ix, iptr
                  fun(iptr)=cfac*f1(iq,ix,kode)
c                 if (kode.eq.kprot) write(*,'(3e12.4,i4)')
c    1               xd(ix),q2(iq),fun(iptr),neff(iq)
                  d(iptr)=fun(iptr)*d(iptr)
                  sg(iptr)=fun(iptr)*fun(iptr)*sg(iptr)
               end if
 22            continue
 21         continue
 20      continue
*
      return
      end
